Index: berusky2/src/kofola/Menu.cpp
===================================================================
--- berusky2.orig/src/kofola/Menu.cpp
+++ berusky2/src/kofola/Menu.cpp
@@ -1477,7 +1477,10 @@ void RunMenuSettings(char *p_File_Name,
   lastcmd = 0;
   timercnt = 0;
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    free((void *) res);
+    return;
+  }
   strcpy(dir, DATA_DIR);
 
   //natadhe skript menu
@@ -2024,7 +2027,13 @@ void RunStretchAnimation(char *cScene, i
   if (iLanguageVersion == 4) {
     strcpy(cDir, BITMAP_DIR);
   
-    sprintf(cFile, "%s%cscene%d.pak", cDir, DIR_SLASH, iActualScene);    
+    if (snprintf(cFile, sizeof(cFile), "%s%cscene%d.pak",
+		 cDir, DIR_SLASH, iActualScene) >=
+	(int) sizeof(cFile)) {
+      kprintf(1, "Filename too long: %s%cscene%d.pak",
+	      cDir, DIR_SLASH, iActualScene);
+      return;
+    }
     hArchive = apakopen(cFile, cDir, &idx);
 
     if (!hArchive) {
@@ -2320,7 +2329,10 @@ void RunMenuNewGameScene(char *p_File_Na
   lastcmd = 0;
   timercnt = 0;
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    free((void *) res);
+    return;
+  }
   
   char dir[MAX_FILENAME];
   strcpy(dir, DATA_DIR);
@@ -2785,7 +2797,13 @@ void LoadSceneMap(int *pBmp, char *cScen
 
   if (iLanguageVersion == 4) {
     strcpy(cDir, BITMAP_DIR);
-    sprintf(cFile, "%s%cscene%d.pak", cDir, DIR_SLASH, iScene);
+    if (snprintf(cFile, sizeof(cFile), "%s%cscene%d.pak",
+		 cDir, DIR_SLASH, iActualScene) >=
+	(int) sizeof(cFile)) {
+      kprintf(1, "Filename too long: %s%cscene%d.pak",
+	      cDir, DIR_SLASH, iActualScene);
+      return;
+    }
     hArchive = apakopen(cFile, cDir, &i);
 
     if (!hArchive) {
@@ -3466,7 +3484,10 @@ BRUTAL_RESTART_SCENE_MAP_MENU:
   lastcmd = 0;
   timercnt = 0;
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    free((void *) res);
+    return;
+  }
 
   //natadhe skript menu
   LoadMenuScript(csrriptname, res, &lastcmd);
@@ -3877,7 +3898,10 @@ int RunMenuNewGame(char *p_File_Name, HW
   lastcmd = 0;
   timercnt = 0;
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    free((void *) res);
+    return 1;
+  }
 
   char dir[MAX_FILENAME];
   strcpy(dir, DATA_DIR);
@@ -4325,7 +4349,8 @@ int FillComboProfiles(COMBO_CONTROL * p_
   int isize;
 
   strcpy(dir, PROFILE_DIR);
-  chdir(dir);
+  if (chdir(dir))
+    return 0;
 
   GetPrivateProfileString("game", "last_profile", "c:\\", cprofile, MAX_FILENAME, ini_file);
 
@@ -4379,9 +4404,11 @@ int check_Save_Owner(char *cDir, WCHAR *
 
   int ver;
 
-  getcwd(dir, MAX_FILENAME);
+  if (getcwd(dir, MAX_FILENAME) == NULL)
+    return 0;
 
-  chdir((cDir));
+  if (chdir(cDir))
+    return 0;
 
   ZeroMemory(&pProfile, sizeof(PLAYER_PROFILE));
 
@@ -4390,27 +4417,35 @@ int check_Save_Owner(char *cDir, WCHAR *
 
   file = fopen(text, "rb");
   if (!file) {
-    chdir((dir));
+    /* GCC warns when we don't check the return value of chdir(). For
+       some reason, casting to (void) doesn't work. */
+    if (chdir(dir))
+      return 0;
     return 0;
   }
 
-  fread(&pProfile, sizeof(PLAYER_PROFILE), 1, file);
-  fread(wFileName, 32 * sizeof(WCHAR), 1, file);
-
-  fread(&ver, sizeof(int), 1, file);
+  if (fread(&pProfile, sizeof(PLAYER_PROFILE), 1, file) != 1 ||
+      fread(wFileName, 32 * sizeof(WCHAR), 1, file) != 1 ||
+      fread(&ver, sizeof(int), 1, file) != 1) {
+    fclose(file);
+    return 0;
+  }
 
   if (ver != SAVE_VER) {
     fclose(file);
     return 0;
   }
 
-  fread(wdir, (MAX_FILENAME + 1) * sizeof(WCHAR), 1, file);
-
-  fread(&l_h, sizeof(LEVEL_HEADER), 1, file);
+  if (fread(wdir, (MAX_FILENAME + 1) * sizeof(WCHAR), 1, file) != 1 ||
+      fread(&l_h, sizeof(LEVEL_HEADER), 1, file) != 1) {
+    fclose(file);
+    return 0;
+  }
 
   fclose(file);
 
-  chdir((dir));
+  if (chdir(dir))
+    return 0;
 
   if (wcscmp(pPlayerProfile.cName, pProfile.cName))
     return 0;
@@ -4435,7 +4470,8 @@ int FillListLoad(LIST_VIEW_CONTROL * p_l
   LIST_ITEM_ *list;
   int isize;
 
-  chdir(SAVE_DIR);
+  if (chdir(SAVE_DIR))
+    return 0;
 
   FillStringList(mask, &list, &isize);
 
@@ -4515,7 +4551,10 @@ void RunMenuLoadGameLoad(char *p_File_Na
   lastcmd = 0;
   timercnt = 0;
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    free((void *) res);
+    return;
+  }
 
   char dir[MAX_FILENAME];
   strcpy(dir, DATA_DIR);
@@ -5012,7 +5051,10 @@ void RunMenuLoadGame(char *p_File_Name,
   lastcmd = 0;
   timercnt = 0;
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    free((void *) res);
+    return;
+  }
 
   char dir[MAX_FILENAME];
   strcpy(dir, DATA_DIR);
@@ -5441,7 +5483,7 @@ void RunMenuCibron(char *cBmp)
   dim.t1 = 0;
   dim.t2 = 0;
 
-  memset(key, 0, POCET_KLAVES * sizeof(char));
+  memset(key, 0, POCET_KLAVES * sizeof(int));
 
   ddxBitBlt(HDC2DD, 0, 0, 1024, 768, idx, 0, 0);
 
@@ -5482,7 +5524,7 @@ void RunMenuCinemax(void)
   dim.t1 = 0;
   dim.t2 = 0;
 
-  memset(key, 0, POCET_KLAVES * sizeof(char));
+  memset(key, 0, POCET_KLAVES * sizeof(int));
 
   ddxReleaseBitmap(cib);
   ddxSetCursor(1);
@@ -5572,7 +5614,10 @@ RUN_MENU_BRUTAL_RESTART:
 
   ZeroMemory(res, RES_NUM * sizeof(CMD_LINE));
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    free((void *) res);
+    return;
+  }
 
   char dir[MAX_FILENAME];
   strcpy(dir, DATA_DIR);
@@ -6054,7 +6099,10 @@ void RunMenuChildGame(char *p_File_Name,
   lastcmd = 0;
   timercnt = 0;
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    free((void *) res);
+    return;
+  }
 
   char dir[MAX_FILENAME];
   strcpy(dir, DATA_DIR);
@@ -6500,7 +6548,10 @@ void RunMenuStartGame(char *p_File_Name,
   lastcmd = 0;
   timercnt = 0;
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    free((void *) res);
+    return;
+  }
 
   char dir[MAX_FILENAME];
   strcpy(dir, DATA_DIR);
@@ -7019,7 +7070,10 @@ int RunMenuComixB(char *p_File_Name, HWN
   lastcmd = 0;
   timercnt = 0;
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    free((void *) res);
+    return 0;
+  }
 
   char dir[MAX_FILENAME];
   strcpy(dir, DATA_DIR);
@@ -7399,7 +7453,13 @@ int RunMenuComix(char *p_File_Name, HWND
 
   if (iLanguageVersion == 4) {
     strcpy(cDir, BITMAP_DIR);
-    sprintf(cFile, "%s%cscene%d.pak", cDir, DIR_SLASH, iScene);
+    if (snprintf(cFile, sizeof(cFile), "%s%cscene%d.pak",
+		 cDir, DIR_SLASH, iActualScene) >=
+	(int) sizeof(cFile)) {
+      kprintf(1, "Filename too long: %s%cscene%d.pak",
+	      cDir, DIR_SLASH, iActualScene);
+      return 0;
+    }
     hArchive = apakopen(cFile, cDir, &idx);
 
     if (!hArchive) {
Index: berusky2/src/kofola/Menu2.cpp
===================================================================
--- berusky2.orig/src/kofola/Menu2.cpp
+++ berusky2/src/kofola/Menu2.cpp
@@ -1138,7 +1138,10 @@ void RunMenuSettings2(char *p_File_Name,
   lastcmd = 0;
   timercnt = 0;
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    free((void *) res);
+    return;
+  }
 
   char dir[MAX_FILENAME];
   strcpy(dir, DATA_DIR);
@@ -1696,7 +1699,8 @@ int FillListLoad2(LIST_VIEW_CONTROL2 * p
   LIST_ITEM_ *list;
   int isize;
 
-  chdir(SAVE_DIR);
+  if (chdir(SAVE_DIR))
+    return 0;
 
   FillStringList(mask, &list, &isize);
 
@@ -1806,7 +1810,10 @@ int RunMenuLoadGameLoad2(char *p_File_Na
   lastcmd = 0;
   timercnt = 0;
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    free((void *) res);
+    return 0;
+  }
 
   char dir[MAX_FILENAME];
   strcpy(dir, DATA_DIR);
@@ -2657,7 +2664,10 @@ void RunMenuHelp2(char *p_File_Name, AUD
   lastcmd = 0;
   timercnt = 0;
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    free((void *) res);
+    return;
+  }
 
   char dir[MAX_FILENAME];
   strcpy(dir, DATA_DIR);
@@ -3197,7 +3207,10 @@ void RunMenuLevelStats2(char *p_File_Nam
   lastcmd = 0;
   timercnt = 0;
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    free((void *) res);
+    return;
+  }
 
   char dir[MAX_FILENAME];
   strcpy(dir, DATA_DIR);
@@ -3562,7 +3575,10 @@ void RunMenuTutorial2(char *p_File_Name,
   lastcmd = 0;
   timercnt = 0;
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    free((void *) res);
+    return;
+  }
 
   char dir[MAX_FILENAME];
   strcpy(dir, DATA_DIR);
@@ -3907,7 +3923,13 @@ void RunMenuLoadScreen2(void)
 
     if (iLanguageVersion == 4) {
       strcpy(cDir, BITMAP_DIR);
-      sprintf(cFile, "%s%cscene%d.pak", cDir, DIR_SLASH, iActualScene);
+      if (snprintf(cFile, sizeof(cFile), "%s%cscene%d.pak",
+		   cDir, DIR_SLASH, iActualScene) >=
+	  (int) sizeof(cFile)) {
+	kprintf(1, "Filename too long: %s%cscene%d.pak",
+		cDir, DIR_SLASH, iActualScene);
+	return;
+      }
       hArchive = apakopen(cFile, cDir, &sh);
 
       if (!hArchive) {
Index: berusky2/src/kofola/Tools.cpp
===================================================================
--- berusky2.orig/src/kofola/Tools.cpp
+++ berusky2/src/kofola/Tools.cpp
@@ -33,16 +33,16 @@ void tools_Parse_Command_Line(char *pCom
     strcpy(pDemo, (const char *) &pCommnad[i + 4]);
   }
   else {
+    /* This allows 18 chars for abbreviated month name. Should be more
+       than enough in any locale. */
+    char timestamp[40];
+    time_t date = time(NULL);
+    struct tm *unpacked_date = localtime(&date);
+    size_t ret = strftime(timestamp, sizeof(timestamp),
+			  "[%b_%d_%Y]_[%H_%M_%S]", unpacked_date);
+    assert(ret);
     *demo = 0;
-    sprintf(pDemo, "[%s]_[%s]_[%s].dem", pLevel, __DATE__, __TIME__);
-
-    for (i = 0; i < (int) strlen(pDemo); i++) {
-      if (pDemo[i] == 32)
-        pDemo[i] = '_';
-
-      if (pDemo[i] == ':')
-        pDemo[i] = '_';
-    }
+    sprintf(pDemo, "[%s]_%s.dem", pLevel, timestamp);
 
     //strcpy(pDemo, "Demo.dem");
   }
@@ -85,14 +85,19 @@ void MyMessageBox(HWND hWnd, char *ctagt
   if (!ctagtitle || !ctagtext)
     return;
 
-  getcwd(odir, MAX_FILENAME);
+  if (getcwd(odir, MAX_FILENAME) == NULL)
+    return;
 
   strcpy(dir, BITMAP_DIR);
-  chdir(dir);
+  if (chdir(dir))
+    return;
   hArchive = apakopen(cFontFile[2], dir, &error);
 
   if (!hArchive) {
-    chdir((odir));
+    /* GCC warns when we don't check the return value of chdir(). For
+       some reason, casting to (void) doesn't work. */
+    if (chdir(odir))
+      return;
     return;
   }
   else
@@ -102,7 +107,8 @@ void MyMessageBox(HWND hWnd, char *ctagt
 
   if (!file) {
     apakclose(&hArchive);
-    chdir((odir));
+    if (chdir(odir))
+      return;
   }
 
   agetbuffer(file, (char **) &buffer, &ulsize);
@@ -120,7 +126,10 @@ void MyMessageBox(HWND hWnd, char *ctagt
 
   aclose(file);
   apakclose(&hArchive);
-  chdir((odir));
+  /* GCC warns when we don't check the return value of chdir(). For
+     some reason, casting to (void) doesn't work. */
+  if (chdir(odir))
+    return;
 }
 
 static int translation_table[KEYNUM];
Index: berusky2/src/kofola/animationk.cpp
===================================================================
--- berusky2.orig/src/kofola/animationk.cpp
+++ berusky2/src/kofola/animationk.cpp
@@ -77,7 +77,10 @@ int am_Init(ANIMATION_MODULE * p_am, LEV
     p_am->p_animation[i].p_matrix = -1;
   }
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR)) {
+    kprintf(1, "Unable to change directory to %s", DATA_DIR);
+    return 0;
+  }
 
   pDataArchive->pActualNode = pDataArchive->pRootNode->pNextNode;
 
@@ -785,7 +788,9 @@ void am_Init_Zhave_Castice(LEVELINFO * p
   for (i = 0; i < 100; i++) {
     p_Level->VodniKolaB[i].pCastice = NULL;
     p_Level->VodniKolaB[i].System = (size_ptr)NULL;
+  }
 
+  for (i = 0; i < 10; i++) {
     for (j = 0; j < 64; j++)
       p_Level->VodniKola[i].hHnizdo[j] = 0;
   }
@@ -808,18 +813,18 @@ void am_Init_Zhave_Castice(LEVELINFO * p
     memset(&p_Level->StarL[i], 0, sizeof(STREET_LIGHT_EFFECT));
 
   for (i = 0; i < 2; i++) {
-    memset(&p_Level->StarFall[i], 0, sizeof(FAIRY_EFFECT));
+    memset((void *) &p_Level->StarFall[i], 0, sizeof(FAIRY_EFFECT));
   }
 
   for (i = 0; i < 6; i++) {
-    memset(&p_Level->CandleEffect[i], 0, sizeof(CANDLE_EFFECT));    
+    memset((void *) &p_Level->CandleEffect[i], 0, sizeof(CANDLE_EFFECT));    
     p_Level->CandleEffect[i].hSvetlo = -1;
-    memset(&p_Level->CandleSmoke[i], 0, sizeof(CANDLE_EFFECT));
+    memset((void *) &p_Level->CandleSmoke[i], 0, sizeof(CANDLE_EFFECT));
     p_Level->CandleSmoke[i].hSvetlo = -1;
   }
 
   for (i = 0; i < 4; i++) {
-    memset(&p_Level->FairyEffect[i], 0, sizeof(FAIRY_EFFECT));
+    memset((void *) &p_Level->FairyEffect[i], 0, sizeof(FAIRY_EFFECT));
   }
 }
 
@@ -1271,11 +1276,11 @@ void am_Do_Water_KolaB(LEVELINFO * p_Lev
           p_Level->VodniKolaB[i].dwExpireTime += ber.TimeLastFrame;
 
         if (p_Level->VodniKolaB[i].dwExpireTime >= p_Level->VodniKolaB[i].dwExpire && 
-            p_Level->VodniKolaB[i].hHnizdo[2] != -1)
+            p_Level->VodniKolaB[i].hHnizdo[2] != (size_ptr) -1)
           p_Level->VodniKolaB[i].hHnizdo[2] = -1;
       }
 
-      if (p_Level->VodniKolaB[i].hHnizdo[2] != -1) {
+      if (p_Level->VodniKolaB[i].hHnizdo[2] != (size_ptr) -1) {
         kom_mesh_get_float(p_Level->VodniKolaB[i].hHnizdo[2],
                            &pos[0], &pos[1], &pos[2], &rot);
 
@@ -1782,7 +1787,7 @@ int am_Find_Corresponding_VodniKolaB(int
 
   for (i = 0; i < 100; i++) {
     if (p_Level->VodniKolaB[i].System &&
-        p_Level->VodniKolaB[i].hHnizdo[2] == mesh)
+        p_Level->VodniKolaB[i].hHnizdo[2] == (size_ptr) mesh)
       return i;
   }
 
Index: berusky2/src/kofola/apakdir.cpp
===================================================================
--- berusky2.orig/src/kofola/apakdir.cpp
+++ berusky2/src/kofola/apakdir.cpp
@@ -109,8 +109,10 @@ int achdir(APAK_HANDLE * pHandle, char *
 
 char *agetcwd(APAK_HANDLE * pHandle, char *buffer, int maxlen)
 {
-  if (!pHandle)
-    getcwd(buffer, maxlen);
+  if (!pHandle) {
+    if (getcwd(buffer, maxlen) == NULL)
+      return NULL;
+  }
 
   if (maxlen > 256)
     maxlen = 256;
Index: berusky2/src/kofola/audio_plug-in.cpp
===================================================================
--- berusky2.orig/src/kofola/audio_plug-in.cpp
+++ berusky2/src/kofola/audio_plug-in.cpp
@@ -86,7 +86,10 @@ int ap_Load_Sound_List(AUDIO_DATA * p_ad
   int c = iStart;
   int iMaterial = 0;
 
-  chdir(p_ber->dir.sound_dir);
+  if (chdir(p_ber->dir.sound_dir)) {
+    kprintf(1, "Cannot change directory to %s", p_ber->dir.sound_dir);
+    return 0;
+  }
 
   if (!strlen(cFile))
     return 0;
@@ -132,7 +135,10 @@ int ap_Load_Play_List(char *p_File_Name,
   if (p_ad->p_Play_List)
     return 0;
 
-  chdir(p_ber->dir.music_dir);
+  if (chdir(p_ber->dir.music_dir)) {
+    kprintf(1, "Cannot change directory to %s", p_ber->dir.music_dir);
+    return 0;
+  }
 
   file = fopen(p_File_Name, "r");
   if (!file) {    
@@ -141,7 +147,11 @@ int ap_Load_Play_List(char *p_File_Name,
     return 0;
   }
 
-  fgets(text, 30, file);
+  if (fgets(text, 30, file) == NULL) {
+    kprintf(1, "Cannot read play list file");
+    MyMessageBox(NULL, "##error_title", "##play_list_error", "");
+    return 0;
+  }
   p_ad->Size_of_Play_List = atoi(text);
 
   p_ad->p_Play_List = (PLAY_LIST_ITEM *) malloc((p_ad->Size_of_Play_List) * sizeof(PLAY_LIST_ITEM));
@@ -153,7 +163,11 @@ int ap_Load_Play_List(char *p_File_Name,
 
   for (i = 0; i < p_ad->Size_of_Play_List; i++) {
     char *p_name = p_ad->p_Play_List[i].Song_Name;
-    fgets(p_name, 30, file);
+    if (fgets(p_name, 30, file) == NULL) {
+      kprintf(1, "Cannot read play list file");
+      MyMessageBox(NULL, "##error_title", "##play_list_error", "");
+      return 0;
+    }
     newline_cut(p_name);
   }
   fclose(file);
Index: berusky2/src/kofola/controls.cpp
===================================================================
--- berusky2.orig/src/kofola/controls.cpp
+++ berusky2/src/kofola/controls.cpp
@@ -3218,7 +3218,7 @@ int co_Handle_Edit(CONTROL_EDIT * p_ed,
       int   size;
 
       if (co_Handle_Edit_Key_Filter() || (co_Handle_wsclen(p_ed) && !key[K_BKSP])) {
-        memset(key, 0, POCET_KLAVES * sizeof(char));
+        memset(key, 0, POCET_KLAVES * sizeof(int));
         return 1;
       }
 
@@ -3226,18 +3226,18 @@ int co_Handle_Edit(CONTROL_EDIT * p_ed,
       size = MultiByteToWideChar(CP_ACP, 0, (char *) &key_pressed, 1, wt, sizeof(wt)/sizeof(wt[0]));
       if(size > 1) {
         // we have got some unsupported character - ignore it
-        memset(key, 0, POCET_KLAVES * sizeof(char));
+        memset(key, 0, POCET_KLAVES * sizeof(int));
         return 1;
       }
       wt[0] = co_ToUnicode(key_pressed);
 
       if (!wt[0]) {
-        memset(key, 0, POCET_KLAVES * sizeof(char));
+        memset(key, 0, POCET_KLAVES * sizeof(int));
         return 1;
       }
 
       if (wt[0] == '_') {
-        memset(key, 0, POCET_KLAVES * sizeof(char));
+        memset(key, 0, POCET_KLAVES * sizeof(int));
         return 1;
       }
 
@@ -3280,7 +3280,7 @@ int co_Handle_Edit(CONTROL_EDIT * p_ed,
 
       p_ed->tx = draw_edit(p_ed, x, y, hdc, xcor, ycor);
 
-      memset(key, 0, POCET_KLAVES * sizeof(char));
+      memset(key, 0, POCET_KLAVES * sizeof(int));
     }
   }
 
Index: berusky2/src/kofola/controls3d.cpp
===================================================================
--- berusky2.orig/src/kofola/controls3d.cpp
+++ berusky2/src/kofola/controls3d.cpp
@@ -3004,7 +3004,7 @@ int co2_Handle_Edit(CONTROL_EDIT2 * p_ed
       int size;
 
       if (co_Handle_Edit_Key_Filter() || (co2_Handle_wsclen(p_ed) && !key[K_BKSP])) {
-        memset(key, 0, POCET_KLAVES * sizeof(char));
+        memset(key, 0, POCET_KLAVES * sizeof(int));
         return 1;
       }
 
@@ -3012,18 +3012,18 @@ int co2_Handle_Edit(CONTROL_EDIT2 * p_ed
       size = MultiByteToWideChar(CP_ACP, 0, (char *) &key_pressed, 1, wt, sizeof(wt) / sizeof(wt[0]));
       if(size > 1) {
         // we have got some unsupported character - ignore it
-        memset(key, 0, POCET_KLAVES * sizeof(char));
+        memset(key, 0, POCET_KLAVES * sizeof(int));
         return 1;
       }      
       wt[0] = co_ToUnicode(key_pressed);
 
       if (!wt[0]) {
-        memset(key, 0, POCET_KLAVES * sizeof(char));
+        memset(key, 0, POCET_KLAVES * sizeof(int));
         return 1;
       }
 
       if (wt[0] == '_') {
-        memset(key, 0, POCET_KLAVES * sizeof(char));
+        memset(key, 0, POCET_KLAVES * sizeof(int));
         return 1;
       }
 
@@ -3079,7 +3079,7 @@ int co2_Handle_Edit(CONTROL_EDIT2 * p_ed
         TRANSCOLOR);
 
       p_ed->tx = xt;
-      memset(key, 0, POCET_KLAVES * sizeof(char));
+      memset(key, 0, POCET_KLAVES * sizeof(int));
     }
   }
 
Index: berusky2/src/kofola/credits.cpp
===================================================================
--- berusky2.orig/src/kofola/credits.cpp
+++ berusky2/src/kofola/credits.cpp
@@ -219,7 +219,8 @@ int cr_Credits(HWND hWnd, AUDIO_DATA * p
 	}
 
   strcpy(text, BITMAP_DIR);
-	chdir(text);
+	if (chdir(text))
+		return 0;
 	hArchive = apakopen(cFontFile[2], text, &error);
 
 	if(!hArchive)
@@ -471,7 +472,8 @@ int cr_CreditsUNI(HWND hWnd, AUDIO_DATA
 	}
 
   strcpy(text,BITMAP_DIR);
-	chdir(text);
+	if (chdir(text))
+		return 0;
 
 	hArchive = apakopen(cFontFile[2], text, &error);
 	
Index: berusky2/src/kofola/font.cpp
===================================================================
--- berusky2.orig/src/kofola/font.cpp
+++ berusky2/src/kofola/font.cpp
@@ -1,4 +1,5 @@
 #include <stdio.h>
+#include <errno.h>
 #include "font.h"
 #include "2D_graphic.h"
 #include "menu_def.h"
@@ -370,7 +371,11 @@ void fn_Gen_Texture(char ** lpTexture, i
 int fn_Open_Archive(char *cFile, APAK_HANDLE ** pAHandle, char *p_dir)
 {
   int e;
-  chdir(p_dir);
+  if (chdir(p_dir)) {
+    kprintf(1, "Unable to change directory to %s: %s",
+	    p_dir, strerror(errno));
+    return 0;
+  }
 
   (*pAHandle) = apakopen(cFile, p_dir, &e);
 
@@ -877,7 +882,8 @@ void fn_Convert_Rect(char *cFile, int xm
   char t[32];
   float *fl1, *fl2, *fl3, *fl4, *fl5;
 
-  getcwd(text, 255);
+  if (getcwd(text, 255) == NULL)
+    return;
 
   f = fopen("fontout.txt", "w");
   fi = fopen("font_def.txt", "r");
@@ -888,7 +894,11 @@ void fn_Convert_Rect(char *cFile, int xm
         {
           if (gt->command[i].LastParam > 5 &&
             gt->command[i].Parametr[0].Type == 3) {
-            fgets(textt, 256, fi);
+            if (fgets(textt, 256, fi) == NULL) {
+	      fclose(fi);
+	      fclose(f);
+	      return;
+	    }
             strncpy(t, textt, 10);
             t[10] = '\0';
             strcpy(text, "");
Index: berusky2/src/kofola/font3d.cpp
===================================================================
--- berusky2.orig/src/kofola/font3d.cpp
+++ berusky2/src/kofola/font3d.cpp
@@ -1,4 +1,5 @@
 #include <stdio.h>
+#include <errno.h>
 #include "Apak.h"
 #include "font3d.h"
 //#include "2d_graphic.h"
@@ -631,7 +632,11 @@ int fn2_Open_Archive(char *cFile, APAK_H
 {
   int e;
 
-  chdir(p_dir);
+  if (chdir(p_dir)) {
+    kprintf(1, "Unable to change directory to %s: %s",
+	    p_dir, strerror(errno));
+    return 0;
+  }
   (*pAHandle) = apakopen(cFile, p_dir, &e);
 
   if (!(*pAHandle)) {
@@ -1149,7 +1154,11 @@ void fn2_Convert_Rect(char *cFile, int x
         {
           if (gt->command[i].LastParam > 5 &&
             gt->command[i].Parametr[0].Type == 3) {
-            fgets(textt, 256, fi);
+            if (fgets(textt, 256, fi) == NULL) {
+	      fclose(fi);
+	      fclose(f);
+	      return;
+	    }
             strncpy(t, textt, 10);
             t[10] = '\0';
             strcpy(text, "");
Index: berusky2/src/kofola/game_init.cpp
===================================================================
--- berusky2.orig/src/kofola/game_init.cpp
+++ berusky2/src/kofola/game_init.cpp
@@ -2,6 +2,7 @@
 // version 0.0.1
 //------------------------------------------------------------------------------------------------
 #include <stdio.h>
+#include <errno.h>
 #include "Apak.h"
 #include "adas.h"
 
@@ -41,7 +42,11 @@ int gi_Open_Archive(char *cFile, APAK_HA
 {
   int e;
 
-  chdir(p_dir);
+  if (chdir(p_dir)) {
+    kprintf(1, "Unable to change directory to %s: %s",
+	    p_dir, strerror(errno));
+    return 0;
+  }
   (*pAHandle) = apakopen(cFile, p_dir, &e);
 
   if (!(*pAHandle)) {
@@ -185,7 +190,11 @@ void gi_Init_Sound_Engine(AUDIO_DATA *p_
 			kprintf(1, "Extensions: %s", cString);			
 
 			p_ad->bAudio = 1;
-			chdir(p_ber->dir.sound_dir);
+			if (chdir(p_ber->dir.sound_dir)) {
+				kprintf(1, "Cannot change directory to %s: %s",
+					p_ber->dir.sound_dir, strerror, errno);
+				return;
+			}
 			achdir(pSndArchive, p_ber->dir.sound_dir);
 
 			ap_Load_Sound_List(p_ad, "basicset.dat", 0);
Index: berusky2/src/kofola/game_logic.cpp
===================================================================
--- berusky2.orig/src/kofola/game_logic.cpp
+++ berusky2/src/kofola/game_logic.cpp
@@ -9431,19 +9431,17 @@ int gl_Moveto_Beatle(int btl, LEVELINFO
 
 int gl_Screen_Shot(int i)
 {
-  char text[256], t[32];
-  char z[] = "0000";
+  char text[MAX_FILENAME];
   FILE *f = NULL;
 
   do {
-    strcpy(text, CurrentWorkingDirectory);    
-    strcat(text, DIR_SLASH_STRING"screenshot");
-
-    itoa(i, t, 10);
+    if (snprintf(text, sizeof(text), "%s%s%04d.bmp",
+		 CurrentWorkingDirectory,
+		 DIR_SLASH_STRING"screenshot", i) >=
+	(int) sizeof(text)) {
+      break;
+    }
 
-    strncat(text, z, 4 - strlen(t));
-    strcat(text, t);
-    strcat(text, ".bmp");
     f = fopen(text, "r");
     if (!f)
       break;
@@ -10415,9 +10413,11 @@ PLAY_LEVEL_START:
     int isize;
     char ctext[MAX_FILENAME];
 
-    chdir(GAME_LEVEL_DIR);
+    if (chdir(GAME_LEVEL_DIR))
+      return -1;
     lsi_Get_Dir_Name(ctext, cLevelName);
-    chdir(ctext);
+    if (chdir(ctext))
+      return -1;
 
     kprintf(1, "lsi_Create_Level_Raw...");
     if (!lsi_Create_Level_Raw(cLevelName, &b_l_d, &isize))
@@ -10427,9 +10427,11 @@ PLAY_LEVEL_START:
     kprintf(1, "kom_load_level...");
     kom_load_level(cLevelName, 1, bRestart, b_l_d, isize);
     
-    chdir(GAME_LEVEL_DIR);
+    if (chdir(GAME_LEVEL_DIR))
+      return -1;
     lsi_Get_Dir_Name(ctext, cLevelName);
-    chdir(ctext);
+    if (chdir(ctext))
+      return -1;
 
     kprintf(1, "free((void *) b_l_d);");
     free((void *) b_l_d);
Index: berusky2/src/kofola/game_main.cpp
===================================================================
--- berusky2.orig/src/kofola/game_main.cpp
+++ berusky2/src/kofola/game_main.cpp
@@ -56,7 +56,8 @@ int winmain_Game_Run(char *p_Level_Name)
   kprintf(1, "Kofola - verze zdrojaku: MASTER %d.%d", VERZEHI, VERZELO);
 
   gi_Set_Win_Version();
-  getcwd(CurrentWorkingDirectory, MAX_FILENAME);
+  if (getcwd(CurrentWorkingDirectory, MAX_FILENAME) == NULL)
+    return 0;
 
   srand((unsigned) time(NULL));
 
@@ -128,9 +129,23 @@ int winmain_Game_Run(char *p_Level_Name)
   }
 
 	gi_Init_Sound_Engine(&ad);
-	chdir(p_ber->dir.music_dir);
+	if (chdir(p_ber->dir.music_dir)) {
+	  apakclose(&pDataArchive);
+	  apakclose(&p3DMArchive);
+	  apakclose(&pControlsArchive);
+	  apakclose(&pBmpArchive);
+	  apakclose(&pSndArchive);
+	  return 0;
+	}
 	ap_Load_Play_List("play_list.dat",&ad);
-  chdir(p_ber->dir.sound_dir);
+  if (chdir(p_ber->dir.sound_dir)) {
+    apakclose(&pDataArchive);
+    apakclose(&p3DMArchive);
+    apakclose(&pControlsArchive);
+    apakclose(&pBmpArchive);
+    apakclose(&pSndArchive);
+    return 0;
+  }
 
   ap_Load_Material_List("material.dat", &ad);
 
Index: berusky2/src/kofola/grammar.cpp
===================================================================
--- berusky2.orig/src/kofola/grammar.cpp
+++ berusky2/src/kofola/grammar.cpp
@@ -55,7 +55,8 @@ char gr_Load_Grammar(char *pFile, GRAMMA
   FILE *file;
   char text[256];
 
-  chdir(DATA_DIR);
+  if (chdir(DATA_DIR))
+    return 0;
 
   file = aopen(pDataArchive, pFile, "r");
 
